var MiniIcons =
[
	"tstorms",		//0 	tornado
	"tstorms",		//1 	tropical storm
	"tstorms",		//2 	hurricane
	"tstorms",		//3 	severe thunderstorms
	"tstorms",		//4 	thunderstorms
	"rain_snow",		//5 	mixed rain and snow
	"sleet",		//6 	mixed rain and sleet
	"sleet",		//7 	mixed snow and sleet
	"freezing_drizzle",		//8 	freezing drizzle
	"light_rain",		//9 	drizzle
	"sleet",		//10 	freezing rain
	"showers",		//11 	showers
	"showers",		//12 	showers
	"flurries",		//13 	snow flurries
	"light_snow",		//14 	light snow showers
	"blowing_snow",		//15 	blowing snow
	"snow",		//16 	snow
	"hail",		//17 	hail
	"sleet",		//18 	sleet
	"windy_blustery",		//19 	dust
	"fog",		//20 	foggy
	"haze",		//21 	haze
	"haze",		//22 	smoky
	"windy_blustery",		//23 	blustery
	"windy_blustery",		//24 	windy
	"cold",		//25 	cold
	"cloudy",		//26 	cloudy
	"mostly_cloudy_night",		//27 	mostly cloudy (night)
	"mostly_cloudy_day",		//28 	mostly cloudy (day)
	"partly_cloudy_night",		//29 	partly cloudy (night)
	"partly_cloudy_day",		//30 	partly cloudy (day)
	"sunny_night",		//31 	clear (night)
	"sunny_day",		//32 	sunny
	"sunny_night",		//33 	fair (night)
	"sunny_day",		//34 	fair (day)
	"hail",		//35 	mixed rain and hail
	"sunny_hot",		//36 	hot
	"tstorms",		//37 	isolated thunderstorms
	"tstorms",		//38 	scattered thunderstorms
	"tstorms",		//39 	scattered thunderstorms
	"showers",		//40 	scattered showers
	"heavy_snow",		//41 	heavy snow
	"snow_showers",		//42 	scattered snow showers
	"heavy_snow",		//43 	heavy snow
	"partly_cloudy",		//44 	partly cloudy
	"tstorms",		//45 	thundershowers
	"snow_showers",		//46 	snow showers
	"tstorms",		//47 	isolated thundershowers
	"dunno",		//3200 	not available
]

function constructError (string)
{
	return {error:true, errorString:string};
}

function findChild (element, nodeName)
{
	var child;
	
	for (child = element.firstChild; child != null; child = child.nextSibling)
	{
		if (child.nodeName == nodeName)
			return child;
	}
	
	return null;
}


function fetchWeatherData (callback, zip)
{
	url="http://weather.yahooapis.com/forecastrss?u=f&p=" //u=Farenheit, because accuWeather sucks
	
	var xml_request = new XMLHttpRequest();
	xml_request.onload = function(e) {xml_loaded(e, xml_request, callback);}
	xml_request.overrideMimeType("text/xml");
	xml_request.open("GET", url+zip);
	xml_request.setRequestHeader("Cache-Control", "no-cache");
	xml_request.send(null);	
	
	return xml_request;
}

function xml_loaded (event, request, callback)
{
	if (request.responseXML)
	{
	 	var obj = {error:false, errorString:null};
		var effectiveRoot = findChild(findChild(request.responseXML, "rss"), "channel");
		obj.city = findChild(effectiveRoot, "yweather:location").getAttribute("city");
		obj.realFeel = findChild(effectiveRoot, "yweather:wind").getAttribute("chill");//Only accounts for windChill
		
		conditionTag = findChild(findChild(effectiveRoot, "item"), "yweather:condition");
		obj.temp = conditionTag.getAttribute("temp");
		obj.icon = conditionTag.getAttribute("code");
		obj.description = conditionTag.getAttribute("text"); 
		callback (obj); 
	}else{
		callback ({error:true, errorString:"XML request failed. no responseXML"});
	}
}


function validateWeatherLocation (location, callback)
{
	var obj = {error:false, errorString:null, cities: new Array};
	obj.cities[0] = {zip: location}; //Not very clever, are we?
	callback (obj);
}